import org.apache.cordova.api.CallbackContext;
import org.apache.cordova.api.CordovaPlugin;
import org.json.JSONObject;
import org.json.JSONArray;
import org.json.JSONException;


public class FileBrowser extends CordovaPlugin {
    public static final String ACTION_ADD_FILESYSTEM_ENTRY = "getAndroidFileSystem";

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        try {
            if (ACTION_ADD_FILESYSTEM_ENTRY.equals(action)) {
                JSONObject arg_object = args.getJSONObject(0);
                Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
                intent.setType(arg_object.getString('type'));
                this.cordova.getActivity().startActivityForResult(intent, ACTION_ADD_FILESYSTEM_ENTRY);


                //this.cordova.getActivity().startActivity(calIntent);
                //callbackContext.success();
                return true;
            }
            callbackContext.error("Invalid action");
            return false;
        } catch(Exception e) {
            System.err.println("Exception: " + e.getMessage());
            callbackContext.error(e.getMessage());
            return false;
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // TODO Auto-generated method stub
        switch(requestCode){
            case ACTION_ADD_FILESYSTEM_ENTRY:
                if(resultCode==RESULT_OK){
                    String FilePath = data.getData().getPath();
                    if (callbackContext != null) {
                        callbackContext.sendPluginResult(result);
                        callbackContext = null;
                    }
                }
                break;
            default:
                callbackContext.error("Invalid Result");
        }
    }

}