/**
 * Created by pictoconnection on 12/11/15.
 */
(function() {
  /**
   * Product iOS
   * @returns {*}
   * @constructor
   */
  this.ProductIAP = function() {
    'use strict';
    var _this = this;
    var _options = arguments[0];
    this.loaded = false;
    this.id = _options.id;
    this.type = _options.type;
    this.product = null;

    if (!_options.id || !_options.type) {
      return console.log('Error initializing productIAP --> id: ' + _options.id + ', type: ' + _options.type);
    }
  };

  /**
   * Register events store store;
   * @param store
   */
  ProductIAP.prototype.bindEvents = function(store) {
    'use strict';
    console.log(this);
    store.when(this.id).loaded(this.funcLoaded);
    store.when(this.id).updated(this.funcUpdated);
    store.when(this.id).approved(this.funcApproved);
    store.when(this.id).owned(this.funcOwned);
    store.when(this.id).cancelled(this.funcCancelled);
    store.when(this.id).refunded(this.funcRefunded);
    store.when(this.id).verified(this.funcVerified);
    store.when(this.id).unverified(this.funcUnverified);
    store.when(this.id).expired(this.funcExpired);
  };

  /**
   * Unregister Events store
   * @param store
   */
  ProductIAP.prototype.unbindEvents = function(store) {
    'use strict';
    store.off(this.funcLoaded);
    store.off(this.funcUpdated);
    store.off(this.funcApproved);
    store.off(this.funcOwned);
    store.off(this.funcCancelled);
    store.off(this.funcRefunded);
    store.off(this.funcVerified);
    store.off(this.funcUnverified);
    store.off(this.funcExpired);
  };

  /**
   * Called when product data is loaded from the store.
   * @param product
   */
  ProductIAP.prototype.funcLoaded = function(product) {
    console.log(this);
    this.loaded = true;
    console.log('Product ' + product.id + ' --> ' + 'loaded!');
  };

  /**
   * Called when any change occured to a product.
   * @param product
   */
  ProductIAP.prototype.funcUpdated = function(product) {
    this.product = product;
    console.log('Product ' + product.id + ' --> ' + 'updated!');
  };

  /**
   * Called when a product order is approved.
   * @param product
   */
  ProductIAP.prototype.funcApproved = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'approved!');
  };

  /**
   * * Called when a non-consumable product or subscription is owned.
   * @param product
   */
  ProductIAP.prototype.funcOwned = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'owned!');
  };

  /**
   * Called when a product order is cancelled by the user.
   */
  ProductIAP.prototype.funcCancelled = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'cancelled!');
  };

  /**
   * Called when an order is refunded by the user.
   * @param product
   */
  ProductIAP.prototype.funcRefunded = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'refunded!');
  };

  /**
   * Called when receipt validation successful
   * @param product
   */
  ProductIAP.prototype.funcVerified = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'verified!');
  };

  /**
   * Called when receipt verification failed
   * @param product
   */
  ProductIAP.prototype.funcUnverified = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'unverified!');
  };

  /**
   * Called when validation find a subscription to be expired
   * @param product
   */
  ProductIAP.prototype.funcExpired = function(product) {
    console.log('Product ' + product.id + ' --> ' + 'expired!');
  };
}());
