/*global require*/
var mysql = require("mysql"),
    crypto = require("crypto"),
    config = require("../config");

var User = function () {};

User.findOne = function (username, callback) {
    'use strict';
    var connection = mysql.createConnection(config.db_config);

    connection.connect();

    var sql = "SELECT * FROM ?? WHERE ?? = ?";
    var inserts = ['users', 'user_email', username];
    sql = mysql.format(sql, inserts);

    connection.query(sql, function(err, data) {
      if(data.length > 1){
        callback("Error with database", null);
      }else{
        console.info("user findOne -- query callback");
        console.info(err);
        console.info(data);
          if (!err) {
              callback(null, data[0]);
          } else {
              console.error(err);
              callback(null, false)
          }
      }
      
      
    });

    connection.end();
};

User.authenticate = function (username, password, callback) {
  console.log(username)
  console.log(password)
  User.findOne(username, function(error, aUser){
    if(error){
      return callback(null, false);
    }else{
      if(!aUser){
        callback(null, false);
      }else{
        var shasum = crypto.createHash('sha1');
        shasum.update(password);
        input_pass = shasum.digest('hex');
        
        if(aUser.password == input_pass){
          return callback(null, aUser);
        }else{
          return callback(null, aUser);
        }

      }
    }
  });
};


User.save = function (aUser, callback) {

  var myKey = aUser.emailAddress;
  var shasum = crypto.createHash('sha1');
  shasum.update(aUser.password);
  aUser.user_password_hash = shasum.digest('hex');
  delete aUser["password"];
  
  var connection = mysql.createConnection(config.db_config);

  connection.connect();
  connection.query('INSERT INTO users SET ?', aUser, function(err, result) {
    if(err){
      console.error(err.code);
      callback(err.code, null);
    }else{
      console.info("User.save - INSERT CALLBACK");
      console.info(result);
      connection.query('SELECT * FROM users WHERE user_id = ?', result.insertId, function(err, data){
        if(data.length > 1){
          callback("Error with database", null);
        }else{
          callback(null, data[0]);
        }
      });
    }
  });
  

}


User.savePat = function (aUser, callback) { 
  var connection = mysql.createConnection(config.db_config);

  connection.connect();
  connection.query('SELECT user_id FROM users WHERE user_email = ?', aUser.user_email, function(err, data){
    if(data.length < 1){
      callback("Error with database", null);
    }else{
      var user_id = data[0].user_id;
      if(aUser.tea != undefined ){
        teaStr = (aUser.tea).toString();
      }else{
        teaStr = "";
      }

      if(aUser.paralisis != undefined ){
        paralisisStr = (aUser.paralisis).toString();
      }else{
        paralisisStr = "";
      }

      var post  = {
        user_id: user_id,
        patient_name: aUser.patient_name,
        patient_last: aUser.patient_last,
        gender: aUser.gender,
        trans_lang : aUser.trans_lang,
        type_trans : aUser.type_trans,
        habla : aUser.habla,
        autonomy : aUser.autonomy,
        patology : aUser.patology,
        problems : aUser.problems,
        birthdate : aUser.birthdate,
        course : aUser.course,
        problems : aUser.problems,
        retras : aUser.retras,
        tea: teaStr,
        paralisis: paralisisStr   
      };

      connection.query('UPDATE users SET ? WHERE user_email = ?', [{ user_level: aUser.level }, aUser.user_email])
      connection.query('UPDATE users SET ? WHERE user_email = ?', [{ user_active: 1 }, aUser.user_email])

      connection.query('INSERT INTO patients SET ?', post, function(err, result) {
         if(err){
            console.error(err.code);
            callback(err.code, null);
          }else{
            console.info("User.savePatient - INSERT CALLBACK");
            console.info(result);
            connection.query('SELECT * FROM patients WHERE patient_id = ?', result.insertId, function(err, data){
              if(data.length > 1){
                callback("Error with database", null);
              }else{
                callback(null, data[0]);
              }
            });
          }
             
        });  
    }
  });
 
}

module.exports = User;
